﻿local addonName, addonTable = ...
local sbtLABEL = "|TInterface\\Icons\\inv_shield_07:16|t |CFF33CCFF[Barrier Text]|r"
addonTable.myFuncs = {}
addonTable.flags = {}
addonTable.values = {}
addonTable.formatters = {}
addonTable.fonts = {}
addonTable.sounds = {}
local private = addonTable.myFuncs
local flag = addonTable.flags
local value = addonTable.values
local formats = addonTable.formatters
local font = addonTable.fonts
local sound = addonTable.sounds

local green,orange,red,yellow,close = GREEN_FONT_COLOR_CODE,ORANGE_FONT_COLOR_CODE,RED_FONT_COLOR_CODE,YELLOW_FONT_COLOR_CODE,FONT_COLOR_CODE_CLOSE
formats[1]="%s"..green.."%s"..close.." "..orange.."%s"..close.."%s" -- maxrage, predicted, [remaining] [absorbed]
formats[2]=formats[1]
formats[3]="%s"..green.."%s"..close.." "..orange.."%s"..close
formats[4]=formats[3]
formats[5]="%s"..green.."%s"..close
formats[6]=formats[5]
font[1]=STANDARD_TEXT_FONT				font[11]="Interface\\AddOns\\BarrierText\\Fonts\\BorisBlackBloxx.ttf"
font[2]="Fonts\\NIM_____.ttf"			font[12]="Interface\\AddOns\\BarrierText\\Fonts\\Franchise-Bold-hinted.ttf"
font[3]="Fonts\\2002.ttf"				font[13]="Interface\\AddOns\\BarrierText\\Fonts\\merit4.ttf"
font[4]="Fonts\\bHEI01B.ttf"			font[14]="Interface\\AddOns\\BarrierText\\Fonts\\merititalic4.ttf"
font[5]="Fonts\\bKAI00M.ttf"			font[15]="Interface\\AddOns\\BarrierText\\Fonts\\Nouveau_IBM_Stretch.ttf"
font[6]="Fonts\\bLEI00D.ttf"			
font[7]="Fonts\\K_Damage.TTF"			
font[8]="Fonts\\K_Pagetext.TTF"		
font[9]="Fonts\\MORPHEUS.TTF"			
font[10]="Fonts\\SKURRI.TTF"			
sound[1]="Sound\\INTERFACE\\Glyph_MinorCreate.ogg"
sound[2]="Sound\\INTERFACE\\Glyph_MajorCreate.ogg"

local me = UnitName("player")
local myguid
local _,eclass = UnitClass("player")
local STRENGTH_INDEX = 1
local STAMINA_INDEX = 3
local SB_RAGE_MIN = 20
local SB_RAGE_MAX = 60
local BARRIER_ID = 112048
local BARRIER_NAME = (GetSpellInfo(BARRIER_ID))
local MIN_FONT_SIZE, MAX_FONT_SIZE = 10,29

local max, min, mod, format, strlen, strsub = max, min, mod, format, strlen, strsub
local UnitAttackPower, UnitStat, UnitPower, UnitHealthMax, UnitBuff, GetTime = UnitAttackPower, UnitStat, UnitPower, UnitHealthMax, UnitBuff, GetTime

local defaults = {
	["font"] = 7,
	["size"] = 29,
	["format_string"] = 1,
	["sound"] = false,
	["point"] = "CENTER",
	["x"] = 0,
	["y"] = 0,
}

local addon = CreateFrame("Frame")
addon:SetScript("OnEvent",	
	function(self,event,...)
		return self[event] and self[event](...)
	end)
addon:RegisterEvent("ADDON_LOADED")

function addon.ADDON_LOADED(...)
	if (...) == addonName then
		if IsLoggedIn() then
			addon.PLAYER_LOGIN()
		else
			addon:RegisterEvent("PLAYER_LOGIN")
		end
		addon:UnregisterEvent("ADDON_LOADED")
	end
end

function addon.PLAYER_LOGIN()
	if eclass ~= "WARRIOR" then
		private.ShutDown()
	else
		SlashCmdList["BARRIERTEXT"] = private.SlashHandler
		SLASH_BARRIERTEXT1 = "/barriertext"
		SLASH_BARRIERTEXT2 = "/sbt"
		BarrierTextDB = BarrierTextDB or CopyTable(defaults)
		if BarrierTextDB.locked then print(sbtLABEL.." Config: "..yellow.."/sbt"..close.." or "..yellow.."/barriertext"..close) end
		addon:UnregisterEvent("PLAYER_LOGIN")
		myguid = UnitGUID("player")
		flag.inCombat = InCombatLockdown() or UnitAffectingCombat("player") or UnitAffectingCombat("pet")
		if IsPlayerSpell(BARRIER_ID) then
			private.BarrierEvents(true)
		else
			private.BarrierEvents(false)
		end
	end
end

function addon.SPELLS_CHANGED()
	if IsPlayerSpell(BARRIER_ID) then
		private.BarrierEvents(true)
	else
		private.BarrierEvents(false)
	end
end

function addon.PLAYER_REGEN_DISABLED() -- ic
	flag.inCombat = true
	value.absorbed = nil
	private.TextShow()
end

function addon.PLAYER_REGEN_ENABLED() -- ooc
	flag.inCombat = false
	flag.sound = nil
	flag.oldsound = nil
	private.TextShow()
end

function addon.UNIT_POWER_FREQUENT()
	private.BarrierPredict()
end

function addon.UNIT_ATTACK_POWER()
	private.BarrierPredict()
end

function addon.UNIT_STATS()
	private.BarrierPredict()
end

function addon.UNIT_AURA()
	private.BarrierRemain()
end

local subEvents = {["SWING_MISSED"] = {["Type"]=1,["amount"]=3}, ["RANGE_MISSED"] = {["Type"]=4,["amount"]=6},}
subEvents["SPELL_MISSED"] = subEvents["RANGE_MISSED"]
subEvents["SPELL_PERIODIC_MISSED"] = subEvents["RANGE_MISSED"]
subEvents["DAMAGE_SHIELD_MISSED"] = subEvents["RANGE_MISSED"]
subEvents["SPELL_AURA_REMOVED"] = {["Type"]=4,["amount"]=5}
function addon.COMBAT_LOG_EVENT_UNFILTERED(tstamp,subEvent,hideCaster,sourceGUID,sourceName,sourceFlags,sourceRaidFlags,destGUID,destName,destFlags,destRaidFlags,...)
	if not subEvents[subEvent] then return end
	if not destGUID == myguid then return end
	if (select(subEvents[subEvent].Type,...)) == "ABSORB" then
		local absorbed = select(subEvents[subEvent].amount,...)
		value.absorbed = value.absorbed and (value.absorbed + absorbed) or absorbed
	end
	if subEvent == "SPELL_AURA_REMOVED" and select(1,...) == BARRIER_ID then 
		addon:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED") 
		flag.cleu = false 
	end
end

private.SlashHandler = function(msg)
	flag.unlocked = not flag.unlocked
	private.TextShow()
	BarrierTextDB.locked = not flag.unlocked
end

private.BarrierEvents = function(enable)
	if enable then
		private.CreateTextFrame()
		addon:RegisterUnitEvent("UNIT_POWER_FREQUENT","player")
		addon:RegisterUnitEvent("UNIT_AURA","player")
		addon:RegisterUnitEvent("UNIT_ATTACK_POWER","player")
		addon:RegisterUnitEvent("UNIT_STATS","player")
		addon:RegisterEvent("PLAYER_REGEN_DISABLED")
		addon:RegisterEvent("PLAYER_REGEN_ENABLED")
	else
 		addon:RegisterEvent("SPELLS_CHANGED")
		addon:UnregisterEvent("UNIT_POWER_FREQUENT")
		addon:UnregisterEvent("UNIT_AURA")
		addon:UnregisterEvent("UNIT_ATTACK_POWER")
		addon:UnregisterEvent("UNIT_STATS")
		addon:UnregisterEvent("PLAYER_REGEN_DISABLED")
		addon:UnregisterEvent("PLAYER_REGEN_ENABLED")
	end
end

private.ShutDown = function()
	-- Dridzt: "kill em all and let GC sort them out!"
	addon:UnregisterAllEvents()
	addon = wipe(addon)
	addonTable = wipe(addonTable)
	SlashCmdList["BARRIERTEXT"] = nil
	DisableAddOn(addonName) -- we won't load again on this guy/gal
end

private.PlayerStats = function()
	local ap,app, apm = UnitAttackPower("player")
	value.AP = ap+app+apm
	value.STAM = UnitStat("player",STAMINA_INDEX)
	value.STR = UnitStat("player",STRENGTH_INDEX)
	value.RAGE = UnitPower("player",SPELL_POWER_RAGE)
	value.RAGE_MULTIPLIER = value.RAGE<SB_RAGE_MIN and 0 or (max(SB_RAGE_MIN,min(value.RAGE,SB_RAGE_MAX))/SB_RAGE_MAX)
	value.HEALTH_MAX = UnitHealthMax("player")
	if value.RAGE > SB_RAGE_MAX then
		flag.sound = sound[2]
		flag.maxrage = "+"
	elseif value.RAGE > SB_RAGE_MIN then
		flag.sound = sound[1]
		flag.maxrage = ""
	else
		flag.sound = nil
		flag.maxrage = ""
	end
end

private.BarrierRemain = function()
	local name,_,_,_,_,_,ends,_,_,_,id,_,_,_,val1,val2,val3 = UnitBuff("player", BARRIER_NAME)
	if name then
		if not flag.cleu then 
			addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			flag.cleu = true
			value.absorbed = nil
		end
		private.PlayerStats()
		value.remaining = val1
		value.remaining_perc = (value.remaining/value.HEALTH_MAX)*100
	else
		addon:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		flag.cleu = false
		value.remaining = nil
		value.remaining_perc = nil
	end
	private.TextShow()
end

private.BarrierPredict = function()
	private.PlayerStats()
	if value.RAGE_MULTIPLIER > 0 then
		value.predicted = (max(1.8*(value.AP-2*value.STR),value.STAM*2.5))*value.RAGE_MULTIPLIER -- AP scaling was 2x, made 1.8x for 5.2
		value.predicted_perc = (value.predicted/value.HEALTH_MAX)*100
	else
		value.predicted = nil
		value.predicted_perc = nil
	end
	private.TextShow()
end

private.OnEnter = function(frame)
	GameTooltip:SetOwner(frame,"ANCHOR_TOP"); 
  	GameTooltip:SetClampedToScreen(true);
  	GameTooltip:ClearLines();
  	GameTooltip:SetText(sbtLABEL, 1, 0.4, 0.4, 1)
	GameTooltip:AddDoubleLine("/sbt","Lock/Unlock (config mode)",1,0.8,0, 0.4,0.8,0.8)
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine("Config Mode")
 	GameTooltip:AddDoubleLine("Move:","Left-Click+Drag",1,0.8,0, 0.4,0.8,0.8)
 	GameTooltip:AddDoubleLine("Size:","MouseWheel",1,0.8,0, 0.4,0.8,0.8)
 	GameTooltip:AddDoubleLine("Font:","Ctrl+MouseWheel",1,0.8,0, 0.4,0.8,0.8)
 	GameTooltip:AddDoubleLine("Text Format:","Alt+MouseWheel",1,0.8,0, 0.4,0.8,0.8)
 	GameTooltip:AddDoubleLine("Sound Toggle:","Shift+MouseWheel",1,0.8,0, 0.4,0.8,0.8)
	GameTooltip:Show()
end

private.StopMoving = function(frame)
	addon.anchor:StopMovingOrSizing()
	local point,_,_,x,y = addon.anchor:GetPoint(1)
	BarrierTextDB.x = x
	BarrierTextDB.y = y
	BarrierTextDB.point = point
end

private.OnMouseWheel = function(frame, delta)
	if not flag.wheelinput or (GetTime() - flag.wheelinput) > TOOLTIP_UPDATE_TIME then
		flag.wheelinput = GetTime()
		local mode_size = not IsModifierKeyDown()
		local mode_font = IsControlKeyDown()
		local mode_format = IsAltKeyDown()
		local mode_sound = IsShiftKeyDown()
		local newsize, newfont, newformat, newsound
		if mode_size then
			local oldsize = BarrierTextDB.size
			newsize = oldsize+delta
			newsize = max(min(newsize,MAX_FONT_SIZE),MIN_FONT_SIZE)
			BarrierTextDB.size = newsize
		end
		if mode_font then
			local oldfont = BarrierTextDB.font
			newfont = oldfont+delta
			newfont = max(min(newfont,#font),1)
			BarrierTextDB.font = newfont
		end
		if mode_format then
			local oldformat = BarrierTextDB.format_string
			newformat = oldformat+delta
			newformat = max(min(newformat,#formats),1)
			BarrierTextDB.format_string = newformat
		end
		if mode_sound then
			BarrierTextDB.sound = not BarrierTextDB.sound
			if BarrierTextDB.sound then PlaySoundFile(sound[1],"Master") else print(sbtLABEL.." Sound: "..red.."OFF"..close) end
		end
		local valid = addon.text:SetFont(font[BarrierTextDB.font], BarrierTextDB.size, "OUTLINE")
		if not valid then addon.text:SetFont(font[1], 30, "OUTLINE") end
		private.TextShow()
	end
end

private.CreateTextFrame = function()
	if addon.anchor then return end
	local f = CreateFrame("Frame","BarrierTextAnchorFrame",UIParent)
	f:SetFrameStrata("HIGH")
	f:SetFrameLevel(0)
	f:SetWidth(200)
	f:SetHeight(50)
	f:ClearAllPoints()
	f:SetPoint(BarrierTextDB.point,BarrierTextDB.x,BarrierTextDB.y)
	f:SetClampedToScreen(true)
	f:SetClampRectInsets(-50,50,0,0)
	f:SetMovable(true)
 	f:RegisterForDrag("LeftButton")
 	f:SetScript("OnDragStart",f.StartMoving)
 	f:SetScript("OnDragStop", private.StopMoving)
 	f:SetScript("OnHide", private.StopMoving)
 	f:SetScript("OnEnter", private.OnEnter)
 	f:SetScript("OnLeave", GameTooltip_Hide)
 	f:SetScript("OnMouseWheel", private.OnMouseWheel)
	f.Text = f:CreateFontString(nil, "OVERLAY")
	f.Text:SetPoint("LEFT",f)
	f.Text:SetJustifyH("CENTER")
	f.Text:SetJustifyV("CENTER")
	f.Text:SetShadowOffset(1, -1)
	f.Text:SetFont(font[BarrierTextDB.font], BarrierTextDB.size, "OUTLINE")
	addon.anchor = f
	addon.text = f.Text
	addon.anchor:EnableMouse(not BarrierTextDB.locked)
	addon.anchor:EnableMouseWheel(not BarrierTextDB.locked)
	flag.unlocked = not BarrierTextDB.locked
	private.TextShow()
end

private.TextShow = function()
	local maxrage, predicted, remaining, absorbed
 	if flag.inCombat then
 		flag.unlocked = false
 		addon.anchor:EnableMouse(false)
 		addon.anchor:EnableMouseWheel(false)
 		if mod(BarrierTextDB.format_string,2) == 0 then -- even is percentage
 			predicted,remaining = value.predicted_perc and private.FormatNumbers(value.predicted_perc,nil,true) or "0%", value.remaining_perc and private.FormatNumbers(value.remaining_perc,nil,true) or ""
 			absorbed = (not value.remaining_perc and value.absorbed) and "("..private.FormatNumbers(value.absorbed,true)..")" or ""
 		else -- odd is absolute value
 			predicted,remaining = value.predicted and private.FormatNumbers(value.predicted,true) or "0", value.remaining and private.FormatNumbers(value.remaining,true) or ""
 			absorbed = (not value.remaining and value.absorbed) and "("..private.FormatNumbers(value.absorbed,true)..")" or ""
 		end
 		maxrage = flag.maxrage or ""
		addon.text:SetFormattedText(formats[BarrierTextDB.format_string],maxrage,predicted,remaining,absorbed)
		addon.anchor:Show()
		if BarrierTextDB.sound then
			if (flag.sound) then
				if not flag.oldsound or flag.sound ~= flag.oldsound then
					PlaySoundFile(flag.sound, "Master")
					flag.oldsound = flag.sound
				end
			end
		end
 	else
 		if flag.unlocked then
 			if mod(BarrierTextDB.format_string,2) == 0 then
 				predicted, remaining, absorbed = "15%", "11%", "("..private.FormatNumbers(8266,true)..")"
 			else
 				predicted, remaining, absorbed = private.FormatNumbers(17995,true),private.FormatNumbers(11744,true),"("..private.FormatNumbers(8266,true)..")"
 			end
 			maxrage = "+"
 			addon.text:SetFormattedText(formats[BarrierTextDB.format_string],maxrage,predicted,remaining,absorbed) 
 			addon.anchor:EnableMouse(true)
 			addon.anchor:EnableMouseWheel(true)
 			addon.anchor:Show()
 		else
 			addon.anchor:EnableMouse(false)
 			addon.anchor:EnableMouseWheel(false)
 			addon.anchor:Hide()
 		end
 	end
end

private.FormatNumbers = function(value,short,percent)
	local retString = ""
	if value==0 then return retString end
	if short then
		if value >= 10000000 then
			retString = ("%.1fm"):format(value / 1000000)
		elseif value >= 1000000 then
			retString = ("%.2fm"):format(value / 1000000)
		elseif value >= 100000 then
			retString = ("%.0fk"):format(value / 1000)
		elseif value >= 10000 then
			retString = ("%.1fk"):format(value / 1000)
		elseif value > 1000 then
			retString = ("%.2fk"):format(value / 1000)
		else
			retString = value
		end
	elseif percent then
		retString = format("%.1f%%",value)
	else
		retString = format("%d",value)
	end
	return retString;
end